if(!org) var org={};
if(!org.mozdev) org.mozdev={};

org.mozdev.getpartialmessages = function(){
  var pub = {};
  pub.getMessages = function(){
    const MSG_FLAG_PARTIAL = 0x400;
  
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                            .getService(Components.interfaces.nsIXULAppInfo);
    var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                                 .getService(Components.interfaces.nsIVersionComparator);
    if(versionChecker.compare(appInfo.version, "3.0b3") >= 0) {
      var view = gDBView;
      var fldrlocal = view.getFolderForViewIndex(0);
      var messagesEnumerator = fldrlocal.messages;
    }
    else if (versionChecker.compare(appInfo.version, "3.0a1pre") < 0) {
      var view = GetDBView();
      var fldrlocal = view.getFolderForViewIndex(0);
      var messagesEnumerator = fldrlocal.getMessages(null);
    }
    else {
      alert("You are using an unsupported beta version!");
      return;
    }
    
    var msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"]
                      .createInstance(Components.interfaces.nsIMsgWindow);

    if(versionChecker.compare(appInfo.version, "3.0b3") >= 0) {
      var downloadMessages = new Array();
      while (messagesEnumerator.hasMoreElements()) {
        var message = messagesEnumerator.getNext();
        var messageHeader = message.QueryInterface(Components.interfaces.nsIMsgDBHdr);
        if (messageHeader.flags & MSG_FLAG_PARTIAL){
          downloadMessages.push(message);
        }
      }
    
      if (downloadMessages.length > 0) {
        var messages;
        messages = toXPCOMArray(downloadMessages, Components.interfaces.nsIMutableArray);
        fldrlocal.DownloadMessagesForOffline(messages, msgWindow);
      }
    }
    else {
      var downloadMessages = Components.classes["@mozilla.org/supports-array;1"]
                              .createInstance(Components.interfaces.nsISupportsArray);
      while (messagesEnumerator.hasMoreElements()) {
        var message = messagesEnumerator.getNext();
        var messageHeader = message.QueryInterface(Components.interfaces.nsIMsgDBHdr);
        if (messageHeader.flags & MSG_FLAG_PARTIAL){
          downloadMessages.AppendElement(messageHeader);
        }
      }
                  
      if (downloadMessages.Count() > 0) {
        fldrlocal.DownloadMessagesForOffline(downloadMessages, null);
      }
    }    
  }
  return pub;
}();